// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: OddLotTopNPrice.proto

package com.fss.fo.mserver.exchange;

public final class OddLotTopNPriceProtos {
  private OddLotTopNPriceProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface OddLotTopNPriceOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string Id = 1;
    /**
     * <code>optional string Id = 1;</code>
     */
    boolean hasId();
    /**
     * <code>optional string Id = 1;</code>
     */
    java.lang.String getId();
    /**
     * <code>optional string Id = 1;</code>
     */
    com.google.protobuf.ByteString
        getIdBytes();

    // optional string Symbol = 2;
    /**
     * <code>optional string Symbol = 2;</code>
     */
    boolean hasSymbol();
    /**
     * <code>optional string Symbol = 2;</code>
     */
    java.lang.String getSymbol();
    /**
     * <code>optional string Symbol = 2;</code>
     */
    com.google.protobuf.ByteString
        getSymbolBytes();

    // optional string Top = 3;
    /**
     * <code>optional string Top = 3;</code>
     */
    boolean hasTop();
    /**
     * <code>optional string Top = 3;</code>
     */
    java.lang.String getTop();
    /**
     * <code>optional string Top = 3;</code>
     */
    com.google.protobuf.ByteString
        getTopBytes();

    // optional string BuyPrice = 4;
    /**
     * <code>optional string BuyPrice = 4;</code>
     */
    boolean hasBuyPrice();
    /**
     * <code>optional string BuyPrice = 4;</code>
     */
    java.lang.String getBuyPrice();
    /**
     * <code>optional string BuyPrice = 4;</code>
     */
    com.google.protobuf.ByteString
        getBuyPriceBytes();

    // optional string BuyQuantity = 5;
    /**
     * <code>optional string BuyQuantity = 5;</code>
     */
    boolean hasBuyQuantity();
    /**
     * <code>optional string BuyQuantity = 5;</code>
     */
    java.lang.String getBuyQuantity();
    /**
     * <code>optional string BuyQuantity = 5;</code>
     */
    com.google.protobuf.ByteString
        getBuyQuantityBytes();

    // optional string CumulativeBuyVolume = 6;
    /**
     * <code>optional string CumulativeBuyVolume = 6;</code>
     */
    boolean hasCumulativeBuyVolume();
    /**
     * <code>optional string CumulativeBuyVolume = 6;</code>
     */
    java.lang.String getCumulativeBuyVolume();
    /**
     * <code>optional string CumulativeBuyVolume = 6;</code>
     */
    com.google.protobuf.ByteString
        getCumulativeBuyVolumeBytes();

    // optional string SellPrice = 7;
    /**
     * <code>optional string SellPrice = 7;</code>
     */
    boolean hasSellPrice();
    /**
     * <code>optional string SellPrice = 7;</code>
     */
    java.lang.String getSellPrice();
    /**
     * <code>optional string SellPrice = 7;</code>
     */
    com.google.protobuf.ByteString
        getSellPriceBytes();

    // optional string SellQuantity = 8;
    /**
     * <code>optional string SellQuantity = 8;</code>
     */
    boolean hasSellQuantity();
    /**
     * <code>optional string SellQuantity = 8;</code>
     */
    java.lang.String getSellQuantity();
    /**
     * <code>optional string SellQuantity = 8;</code>
     */
    com.google.protobuf.ByteString
        getSellQuantityBytes();

    // optional string CumulativeSellVolume = 9;
    /**
     * <code>optional string CumulativeSellVolume = 9;</code>
     */
    boolean hasCumulativeSellVolume();
    /**
     * <code>optional string CumulativeSellVolume = 9;</code>
     */
    java.lang.String getCumulativeSellVolume();
    /**
     * <code>optional string CumulativeSellVolume = 9;</code>
     */
    com.google.protobuf.ByteString
        getCumulativeSellVolumeBytes();

    // optional string Action = 10;
    /**
     * <code>optional string Action = 10;</code>
     */
    boolean hasAction();
    /**
     * <code>optional string Action = 10;</code>
     */
    java.lang.String getAction();
    /**
     * <code>optional string Action = 10;</code>
     */
    com.google.protobuf.ByteString
        getActionBytes();
  }
  /**
   * Protobuf type {@code com.fss.fo.mserver.exchange.OddLotTopNPrice}
   */
  public static final class OddLotTopNPrice extends
      com.google.protobuf.GeneratedMessage
      implements OddLotTopNPriceOrBuilder {
    // Use OddLotTopNPrice.newBuilder() to construct.
    private OddLotTopNPrice(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private OddLotTopNPrice(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final OddLotTopNPrice defaultInstance;
    public static OddLotTopNPrice getDefaultInstance() {
      return defaultInstance;
    }

    public OddLotTopNPrice getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private OddLotTopNPrice(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              id_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              symbol_ = input.readBytes();
              break;
            }
            case 26: {
              bitField0_ |= 0x00000004;
              top_ = input.readBytes();
              break;
            }
            case 34: {
              bitField0_ |= 0x00000008;
              buyPrice_ = input.readBytes();
              break;
            }
            case 42: {
              bitField0_ |= 0x00000010;
              buyQuantity_ = input.readBytes();
              break;
            }
            case 50: {
              bitField0_ |= 0x00000020;
              cumulativeBuyVolume_ = input.readBytes();
              break;
            }
            case 58: {
              bitField0_ |= 0x00000040;
              sellPrice_ = input.readBytes();
              break;
            }
            case 66: {
              bitField0_ |= 0x00000080;
              sellQuantity_ = input.readBytes();
              break;
            }
            case 74: {
              bitField0_ |= 0x00000100;
              cumulativeSellVolume_ = input.readBytes();
              break;
            }
            case 82: {
              bitField0_ |= 0x00000200;
              action_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.class, com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.Builder.class);
    }

    public static com.google.protobuf.Parser<OddLotTopNPrice> PARSER =
        new com.google.protobuf.AbstractParser<OddLotTopNPrice>() {
      public OddLotTopNPrice parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new OddLotTopNPrice(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<OddLotTopNPrice> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string Id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private java.lang.Object id_;
    /**
     * <code>optional string Id = 1;</code>
     */
    public boolean hasId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          id_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Symbol = 2;
    public static final int SYMBOL_FIELD_NUMBER = 2;
    private java.lang.Object symbol_;
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public boolean hasSymbol() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          symbol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Top = 3;
    public static final int TOP_FIELD_NUMBER = 3;
    private java.lang.Object top_;
    /**
     * <code>optional string Top = 3;</code>
     */
    public boolean hasTop() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional string Top = 3;</code>
     */
    public java.lang.String getTop() {
      java.lang.Object ref = top_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          top_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Top = 3;</code>
     */
    public com.google.protobuf.ByteString
        getTopBytes() {
      java.lang.Object ref = top_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        top_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string BuyPrice = 4;
    public static final int BUYPRICE_FIELD_NUMBER = 4;
    private java.lang.Object buyPrice_;
    /**
     * <code>optional string BuyPrice = 4;</code>
     */
    public boolean hasBuyPrice() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional string BuyPrice = 4;</code>
     */
    public java.lang.String getBuyPrice() {
      java.lang.Object ref = buyPrice_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          buyPrice_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string BuyPrice = 4;</code>
     */
    public com.google.protobuf.ByteString
        getBuyPriceBytes() {
      java.lang.Object ref = buyPrice_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        buyPrice_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string BuyQuantity = 5;
    public static final int BUYQUANTITY_FIELD_NUMBER = 5;
    private java.lang.Object buyQuantity_;
    /**
     * <code>optional string BuyQuantity = 5;</code>
     */
    public boolean hasBuyQuantity() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    /**
     * <code>optional string BuyQuantity = 5;</code>
     */
    public java.lang.String getBuyQuantity() {
      java.lang.Object ref = buyQuantity_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          buyQuantity_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string BuyQuantity = 5;</code>
     */
    public com.google.protobuf.ByteString
        getBuyQuantityBytes() {
      java.lang.Object ref = buyQuantity_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        buyQuantity_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string CumulativeBuyVolume = 6;
    public static final int CUMULATIVEBUYVOLUME_FIELD_NUMBER = 6;
    private java.lang.Object cumulativeBuyVolume_;
    /**
     * <code>optional string CumulativeBuyVolume = 6;</code>
     */
    public boolean hasCumulativeBuyVolume() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    /**
     * <code>optional string CumulativeBuyVolume = 6;</code>
     */
    public java.lang.String getCumulativeBuyVolume() {
      java.lang.Object ref = cumulativeBuyVolume_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          cumulativeBuyVolume_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string CumulativeBuyVolume = 6;</code>
     */
    public com.google.protobuf.ByteString
        getCumulativeBuyVolumeBytes() {
      java.lang.Object ref = cumulativeBuyVolume_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        cumulativeBuyVolume_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string SellPrice = 7;
    public static final int SELLPRICE_FIELD_NUMBER = 7;
    private java.lang.Object sellPrice_;
    /**
     * <code>optional string SellPrice = 7;</code>
     */
    public boolean hasSellPrice() {
      return ((bitField0_ & 0x00000040) == 0x00000040);
    }
    /**
     * <code>optional string SellPrice = 7;</code>
     */
    public java.lang.String getSellPrice() {
      java.lang.Object ref = sellPrice_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          sellPrice_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string SellPrice = 7;</code>
     */
    public com.google.protobuf.ByteString
        getSellPriceBytes() {
      java.lang.Object ref = sellPrice_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        sellPrice_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string SellQuantity = 8;
    public static final int SELLQUANTITY_FIELD_NUMBER = 8;
    private java.lang.Object sellQuantity_;
    /**
     * <code>optional string SellQuantity = 8;</code>
     */
    public boolean hasSellQuantity() {
      return ((bitField0_ & 0x00000080) == 0x00000080);
    }
    /**
     * <code>optional string SellQuantity = 8;</code>
     */
    public java.lang.String getSellQuantity() {
      java.lang.Object ref = sellQuantity_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          sellQuantity_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string SellQuantity = 8;</code>
     */
    public com.google.protobuf.ByteString
        getSellQuantityBytes() {
      java.lang.Object ref = sellQuantity_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        sellQuantity_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string CumulativeSellVolume = 9;
    public static final int CUMULATIVESELLVOLUME_FIELD_NUMBER = 9;
    private java.lang.Object cumulativeSellVolume_;
    /**
     * <code>optional string CumulativeSellVolume = 9;</code>
     */
    public boolean hasCumulativeSellVolume() {
      return ((bitField0_ & 0x00000100) == 0x00000100);
    }
    /**
     * <code>optional string CumulativeSellVolume = 9;</code>
     */
    public java.lang.String getCumulativeSellVolume() {
      java.lang.Object ref = cumulativeSellVolume_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          cumulativeSellVolume_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string CumulativeSellVolume = 9;</code>
     */
    public com.google.protobuf.ByteString
        getCumulativeSellVolumeBytes() {
      java.lang.Object ref = cumulativeSellVolume_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        cumulativeSellVolume_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Action = 10;
    public static final int ACTION_FIELD_NUMBER = 10;
    private java.lang.Object action_;
    /**
     * <code>optional string Action = 10;</code>
     */
    public boolean hasAction() {
      return ((bitField0_ & 0x00000200) == 0x00000200);
    }
    /**
     * <code>optional string Action = 10;</code>
     */
    public java.lang.String getAction() {
      java.lang.Object ref = action_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          action_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Action = 10;</code>
     */
    public com.google.protobuf.ByteString
        getActionBytes() {
      java.lang.Object ref = action_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        action_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      id_ = "";
      symbol_ = "";
      top_ = "";
      buyPrice_ = "";
      buyQuantity_ = "";
      cumulativeBuyVolume_ = "";
      sellPrice_ = "";
      sellQuantity_ = "";
      cumulativeSellVolume_ = "";
      action_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeBytes(3, getTopBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeBytes(4, getBuyPriceBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeBytes(5, getBuyQuantityBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeBytes(6, getCumulativeBuyVolumeBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        output.writeBytes(7, getSellPriceBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        output.writeBytes(8, getSellQuantityBytes());
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        output.writeBytes(9, getCumulativeSellVolumeBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        output.writeBytes(10, getActionBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, getTopBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(4, getBuyPriceBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(5, getBuyQuantityBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(6, getCumulativeBuyVolumeBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(7, getSellPriceBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(8, getSellQuantityBytes());
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(9, getCumulativeSellVolumeBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(10, getActionBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code com.fss.fo.mserver.exchange.OddLotTopNPrice}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPriceOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.class, com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.Builder.class);
      }

      // Construct using com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        id_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        symbol_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        top_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        buyPrice_ = "";
        bitField0_ = (bitField0_ & ~0x00000008);
        buyQuantity_ = "";
        bitField0_ = (bitField0_ & ~0x00000010);
        cumulativeBuyVolume_ = "";
        bitField0_ = (bitField0_ & ~0x00000020);
        sellPrice_ = "";
        bitField0_ = (bitField0_ & ~0x00000040);
        sellQuantity_ = "";
        bitField0_ = (bitField0_ & ~0x00000080);
        cumulativeSellVolume_ = "";
        bitField0_ = (bitField0_ & ~0x00000100);
        action_ = "";
        bitField0_ = (bitField0_ & ~0x00000200);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_descriptor;
      }

      public com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice getDefaultInstanceForType() {
        return com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.getDefaultInstance();
      }

      public com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice build() {
        com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice buildPartial() {
        com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice result = new com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.id_ = id_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.symbol_ = symbol_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.top_ = top_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.buyPrice_ = buyPrice_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.buyQuantity_ = buyQuantity_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000020;
        }
        result.cumulativeBuyVolume_ = cumulativeBuyVolume_;
        if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
          to_bitField0_ |= 0x00000040;
        }
        result.sellPrice_ = sellPrice_;
        if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
          to_bitField0_ |= 0x00000080;
        }
        result.sellQuantity_ = sellQuantity_;
        if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
          to_bitField0_ |= 0x00000100;
        }
        result.cumulativeSellVolume_ = cumulativeSellVolume_;
        if (((from_bitField0_ & 0x00000200) == 0x00000200)) {
          to_bitField0_ |= 0x00000200;
        }
        result.action_ = action_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice) {
          return mergeFrom((com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice other) {
        if (other == com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice.getDefaultInstance()) return this;
        if (other.hasId()) {
          bitField0_ |= 0x00000001;
          id_ = other.id_;
          onChanged();
        }
        if (other.hasSymbol()) {
          bitField0_ |= 0x00000002;
          symbol_ = other.symbol_;
          onChanged();
        }
        if (other.hasTop()) {
          bitField0_ |= 0x00000004;
          top_ = other.top_;
          onChanged();
        }
        if (other.hasBuyPrice()) {
          bitField0_ |= 0x00000008;
          buyPrice_ = other.buyPrice_;
          onChanged();
        }
        if (other.hasBuyQuantity()) {
          bitField0_ |= 0x00000010;
          buyQuantity_ = other.buyQuantity_;
          onChanged();
        }
        if (other.hasCumulativeBuyVolume()) {
          bitField0_ |= 0x00000020;
          cumulativeBuyVolume_ = other.cumulativeBuyVolume_;
          onChanged();
        }
        if (other.hasSellPrice()) {
          bitField0_ |= 0x00000040;
          sellPrice_ = other.sellPrice_;
          onChanged();
        }
        if (other.hasSellQuantity()) {
          bitField0_ |= 0x00000080;
          sellQuantity_ = other.sellQuantity_;
          onChanged();
        }
        if (other.hasCumulativeSellVolume()) {
          bitField0_ |= 0x00000100;
          cumulativeSellVolume_ = other.cumulativeSellVolume_;
          onChanged();
        }
        if (other.hasAction()) {
          bitField0_ |= 0x00000200;
          action_ = other.action_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (com.fss.fo.mserver.exchange.OddLotTopNPriceProtos.OddLotTopNPrice) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string Id = 1;
      private java.lang.Object id_ = "";
      /**
       * <code>optional string Id = 1;</code>
       */
      public boolean hasId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public java.lang.String getId() {
        java.lang.Object ref = id_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          id_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public com.google.protobuf.ByteString
          getIdBytes() {
        java.lang.Object ref = id_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          id_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder clearId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        id_ = getDefaultInstance().getId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }

      // optional string Symbol = 2;
      private java.lang.Object symbol_ = "";
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public boolean hasSymbol() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public java.lang.String getSymbol() {
        java.lang.Object ref = symbol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          symbol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public com.google.protobuf.ByteString
          getSymbolBytes() {
        java.lang.Object ref = symbol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          symbol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder setSymbol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        symbol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder clearSymbol() {
        bitField0_ = (bitField0_ & ~0x00000002);
        symbol_ = getDefaultInstance().getSymbol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder setSymbolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        symbol_ = value;
        onChanged();
        return this;
      }

      // optional string Top = 3;
      private java.lang.Object top_ = "";
      /**
       * <code>optional string Top = 3;</code>
       */
      public boolean hasTop() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional string Top = 3;</code>
       */
      public java.lang.String getTop() {
        java.lang.Object ref = top_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          top_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Top = 3;</code>
       */
      public com.google.protobuf.ByteString
          getTopBytes() {
        java.lang.Object ref = top_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          top_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Top = 3;</code>
       */
      public Builder setTop(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        top_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Top = 3;</code>
       */
      public Builder clearTop() {
        bitField0_ = (bitField0_ & ~0x00000004);
        top_ = getDefaultInstance().getTop();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Top = 3;</code>
       */
      public Builder setTopBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        top_ = value;
        onChanged();
        return this;
      }

      // optional string BuyPrice = 4;
      private java.lang.Object buyPrice_ = "";
      /**
       * <code>optional string BuyPrice = 4;</code>
       */
      public boolean hasBuyPrice() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional string BuyPrice = 4;</code>
       */
      public java.lang.String getBuyPrice() {
        java.lang.Object ref = buyPrice_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          buyPrice_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string BuyPrice = 4;</code>
       */
      public com.google.protobuf.ByteString
          getBuyPriceBytes() {
        java.lang.Object ref = buyPrice_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          buyPrice_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string BuyPrice = 4;</code>
       */
      public Builder setBuyPrice(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        buyPrice_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string BuyPrice = 4;</code>
       */
      public Builder clearBuyPrice() {
        bitField0_ = (bitField0_ & ~0x00000008);
        buyPrice_ = getDefaultInstance().getBuyPrice();
        onChanged();
        return this;
      }
      /**
       * <code>optional string BuyPrice = 4;</code>
       */
      public Builder setBuyPriceBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        buyPrice_ = value;
        onChanged();
        return this;
      }

      // optional string BuyQuantity = 5;
      private java.lang.Object buyQuantity_ = "";
      /**
       * <code>optional string BuyQuantity = 5;</code>
       */
      public boolean hasBuyQuantity() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional string BuyQuantity = 5;</code>
       */
      public java.lang.String getBuyQuantity() {
        java.lang.Object ref = buyQuantity_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          buyQuantity_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string BuyQuantity = 5;</code>
       */
      public com.google.protobuf.ByteString
          getBuyQuantityBytes() {
        java.lang.Object ref = buyQuantity_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          buyQuantity_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string BuyQuantity = 5;</code>
       */
      public Builder setBuyQuantity(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        buyQuantity_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string BuyQuantity = 5;</code>
       */
      public Builder clearBuyQuantity() {
        bitField0_ = (bitField0_ & ~0x00000010);
        buyQuantity_ = getDefaultInstance().getBuyQuantity();
        onChanged();
        return this;
      }
      /**
       * <code>optional string BuyQuantity = 5;</code>
       */
      public Builder setBuyQuantityBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        buyQuantity_ = value;
        onChanged();
        return this;
      }

      // optional string CumulativeBuyVolume = 6;
      private java.lang.Object cumulativeBuyVolume_ = "";
      /**
       * <code>optional string CumulativeBuyVolume = 6;</code>
       */
      public boolean hasCumulativeBuyVolume() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string CumulativeBuyVolume = 6;</code>
       */
      public java.lang.String getCumulativeBuyVolume() {
        java.lang.Object ref = cumulativeBuyVolume_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          cumulativeBuyVolume_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string CumulativeBuyVolume = 6;</code>
       */
      public com.google.protobuf.ByteString
          getCumulativeBuyVolumeBytes() {
        java.lang.Object ref = cumulativeBuyVolume_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          cumulativeBuyVolume_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string CumulativeBuyVolume = 6;</code>
       */
      public Builder setCumulativeBuyVolume(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        cumulativeBuyVolume_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string CumulativeBuyVolume = 6;</code>
       */
      public Builder clearCumulativeBuyVolume() {
        bitField0_ = (bitField0_ & ~0x00000020);
        cumulativeBuyVolume_ = getDefaultInstance().getCumulativeBuyVolume();
        onChanged();
        return this;
      }
      /**
       * <code>optional string CumulativeBuyVolume = 6;</code>
       */
      public Builder setCumulativeBuyVolumeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        cumulativeBuyVolume_ = value;
        onChanged();
        return this;
      }

      // optional string SellPrice = 7;
      private java.lang.Object sellPrice_ = "";
      /**
       * <code>optional string SellPrice = 7;</code>
       */
      public boolean hasSellPrice() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional string SellPrice = 7;</code>
       */
      public java.lang.String getSellPrice() {
        java.lang.Object ref = sellPrice_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          sellPrice_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string SellPrice = 7;</code>
       */
      public com.google.protobuf.ByteString
          getSellPriceBytes() {
        java.lang.Object ref = sellPrice_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          sellPrice_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string SellPrice = 7;</code>
       */
      public Builder setSellPrice(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        sellPrice_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string SellPrice = 7;</code>
       */
      public Builder clearSellPrice() {
        bitField0_ = (bitField0_ & ~0x00000040);
        sellPrice_ = getDefaultInstance().getSellPrice();
        onChanged();
        return this;
      }
      /**
       * <code>optional string SellPrice = 7;</code>
       */
      public Builder setSellPriceBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        sellPrice_ = value;
        onChanged();
        return this;
      }

      // optional string SellQuantity = 8;
      private java.lang.Object sellQuantity_ = "";
      /**
       * <code>optional string SellQuantity = 8;</code>
       */
      public boolean hasSellQuantity() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional string SellQuantity = 8;</code>
       */
      public java.lang.String getSellQuantity() {
        java.lang.Object ref = sellQuantity_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          sellQuantity_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string SellQuantity = 8;</code>
       */
      public com.google.protobuf.ByteString
          getSellQuantityBytes() {
        java.lang.Object ref = sellQuantity_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          sellQuantity_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string SellQuantity = 8;</code>
       */
      public Builder setSellQuantity(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        sellQuantity_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string SellQuantity = 8;</code>
       */
      public Builder clearSellQuantity() {
        bitField0_ = (bitField0_ & ~0x00000080);
        sellQuantity_ = getDefaultInstance().getSellQuantity();
        onChanged();
        return this;
      }
      /**
       * <code>optional string SellQuantity = 8;</code>
       */
      public Builder setSellQuantityBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        sellQuantity_ = value;
        onChanged();
        return this;
      }

      // optional string CumulativeSellVolume = 9;
      private java.lang.Object cumulativeSellVolume_ = "";
      /**
       * <code>optional string CumulativeSellVolume = 9;</code>
       */
      public boolean hasCumulativeSellVolume() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional string CumulativeSellVolume = 9;</code>
       */
      public java.lang.String getCumulativeSellVolume() {
        java.lang.Object ref = cumulativeSellVolume_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          cumulativeSellVolume_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string CumulativeSellVolume = 9;</code>
       */
      public com.google.protobuf.ByteString
          getCumulativeSellVolumeBytes() {
        java.lang.Object ref = cumulativeSellVolume_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          cumulativeSellVolume_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string CumulativeSellVolume = 9;</code>
       */
      public Builder setCumulativeSellVolume(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        cumulativeSellVolume_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string CumulativeSellVolume = 9;</code>
       */
      public Builder clearCumulativeSellVolume() {
        bitField0_ = (bitField0_ & ~0x00000100);
        cumulativeSellVolume_ = getDefaultInstance().getCumulativeSellVolume();
        onChanged();
        return this;
      }
      /**
       * <code>optional string CumulativeSellVolume = 9;</code>
       */
      public Builder setCumulativeSellVolumeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        cumulativeSellVolume_ = value;
        onChanged();
        return this;
      }

      // optional string Action = 10;
      private java.lang.Object action_ = "";
      /**
       * <code>optional string Action = 10;</code>
       */
      public boolean hasAction() {
        return ((bitField0_ & 0x00000200) == 0x00000200);
      }
      /**
       * <code>optional string Action = 10;</code>
       */
      public java.lang.String getAction() {
        java.lang.Object ref = action_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          action_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Action = 10;</code>
       */
      public com.google.protobuf.ByteString
          getActionBytes() {
        java.lang.Object ref = action_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          action_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Action = 10;</code>
       */
      public Builder setAction(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        action_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Action = 10;</code>
       */
      public Builder clearAction() {
        bitField0_ = (bitField0_ & ~0x00000200);
        action_ = getDefaultInstance().getAction();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Action = 10;</code>
       */
      public Builder setActionBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        action_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:com.fss.fo.mserver.exchange.OddLotTopNPrice)
    }

    static {
      defaultInstance = new OddLotTopNPrice(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:com.fss.fo.mserver.exchange.OddLotTopNPrice)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\025OddLotTopNPrice.proto\022\033com.fss.fo.mser" +
      "ver.exchange\"\325\001\n\017OddLotTopNPrice\022\n\n\002Id\030\001" +
      " \001(\t\022\016\n\006Symbol\030\002 \001(\t\022\013\n\003Top\030\003 \001(\t\022\020\n\010Buy" +
      "Price\030\004 \001(\t\022\023\n\013BuyQuantity\030\005 \001(\t\022\033\n\023Cumu" +
      "lativeBuyVolume\030\006 \001(\t\022\021\n\tSellPrice\030\007 \001(\t" +
      "\022\024\n\014SellQuantity\030\010 \001(\t\022\034\n\024CumulativeSell" +
      "Volume\030\t \001(\t\022\016\n\006Action\030\n \001(\tB4\n\033com.fss." +
      "fo.mserver.exchangeB\025OddLotTopNPriceProt" +
      "os"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_fss_fo_mserver_exchange_OddLotTopNPrice_descriptor,
              new java.lang.String[] { "Id", "Symbol", "Top", "BuyPrice", "BuyQuantity", "CumulativeBuyVolume", "SellPrice", "SellQuantity", "CumulativeSellVolume", "Action", });
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
